
//	Copyright 2010 Ohtan's Design Corporation
//
//  Jul. the 22th 2010
//  Crated by A.Ohta
//

#include <htc.h> 
#include "math.h" 
#include "nokiaGlcdlib.h" 
#include "HR.h" 

#define	_XTAL_FREQ			8000000									//	giNbNpj@16F886 3.3VpɕύX

int lValue_Hum,i; 
unsigned char error, byte_1, byte_2,byte_0; 

/************************************************************ 
// writes a byte on the Sensibus and checks the acknowledge 
***************************************************************/ 
//------------------------------------------------------------------------------ 
unsigned char s_write_byte(unsigned char value) 
//------------------------------------------------------------------------------    
       
{ 
    
    
   unsigned char i,error=0; 
   TRIS_DATA = 0;					//SHT11 WRITE...make DATA-line output 
   SCK=0; //initial state 
   for (i=0x80;i>0;i/=2)			//shift bit for masking 
   { 
     __delay_us(20); 
     if (i & value) 
         DATA=1;					//masking value with i , write to SENSI-BUS 
     else 
         DATA=0; 
     SCK=1;							//clk for SENSI-BUS 
      
     __delay_us(20);					//pulswith approx. 5 us 
      
     SCK=0; 
   } 

  
   TRIS_DATA = 1;					//SHT11 READ..make DATA-line input 
   __delay_us(20); 
   SCK=1;							//clk #9 for ack 
   __delay_us(20); 
   SCK=0; 
   error = DATA;					//check ack (DATA will be pulled down by SHT11) 
   return error;					//error=1 in case of no acknowledge 
} 


/****************************************************************************/ 
// reads a byte from the Sensibus and gives an acknowledge in case of "ack=1" 
/****************************************************************************/ 

unsigned char s_read_byte(unsigned char ack) 
{ 
   unsigned char i; int val=0; 
   TRIS_DATA = 1;				//SHT11 READ 
   for (i=0x80;i>0;i/=2)		//shift bit for masking 
   { 
     __delay_us(20); 
     SCK=1;						//clk for SENSI-BUS 
     if (DATA) 
     val=(val | i);				//read bit       
     __delay_us(20); 
     SCK=0; 
   } 
   TRIS_DATA = 0;				//make DATA-Line output 
   DATA=!ack;					//in case of "ack==1" pull down DATA-Line 
   SCK=1;						//clk #9 for ack 
   __delay_us(20);					//pulswith approx. 5 us 
   SCK=0; 
   TRIS_DATA=1; 
   return val; 
} 


//---------------------------------------------------------------------------------- 
void s_transstart(void) 
//---------------------------------------------------------------------------------- 
// generates a transmission start 
//       _____         ________ 
// DATA:      |_______| 
//           ___     ___ 
// SCK : ___|   |___|   |______ 
{ 
   TRIS_DATA = 0;				//SHT11 WRITE - DATA_Line output 

   DATA=1; 
   SCK=0;						//Initial state 
   __delay_us(20); 
   SCK=1; 
   __delay_us(20); 
   DATA=0; 
   __delay_us(20); 
   SCK=0; 
   __delay_us(20); 
   SCK=1; 
   __delay_us(20); 
   DATA=1; 
   __delay_us(20); 
   SCK=0; 
} 


//---------------------------------------------------------------------------------- 
void s_connectionreset(void) 
//---------------------------------------------------------------------------------- 
// communication reset: DATA-line=1 and at least 9 SCK cycles followed by transstart 
//       _____________________________________________________         ________ 
// DATA:                                                      |_______| 
//          _    _    _    _    _    _    _    _    _        ___     ___ 
// SCK : __| |__| |__| |__| |__| |__| |__| |__| |__| |______|   |___|   |______ 
{ 
   unsigned char i; 
   TRIS_DATA = 0;				//SHT11 WRITE 
   DATA=1; SCK=0;				//Initial state 
   for(i=0;i<12;i++)			//12 SCK cycles....more than 9 for safe being 
   { 
    SCK=1; 
     __delay_us(20); 
     SCK=0; 
   } 
   s_transstart();				//transmission start 
} 

void shtinit(void) 
{ 
	s_connectionreset(); 
	__delay_us(20); 
} 

void thp(UW Pres,UH Temp)
{

	UH	Value;

	Value = (UH)(Pres / 400L);											//	ʏ300 `1200͈͓̔̂͂

	if (Temp & (UH)BIT15) {												//	}CiXwH
		Temp = (~Temp) + 1;												//	ΒlZo
	}


//		Meausure Humidity 
    
	s_connectionreset();										//Reset Sensor BUS 
	s_transstart();												//transmission start 
	s_write_byte(MEASURE_HUMI);									//measure Humidity 
	for(i=0;i<9999;i++) 
		{if (DATA==0) break;} 
	if (DATA=1) s_connectionreset(); 
	//while (DATA); //wait until SHT11 ends measurements 
	//Save highest byte read, in RAM 
	byte_1 =(unsigned char)  s_read_byte(ACK); 
	//Save lowest byte read, in RAM 
	byte_2 = (unsigned char) s_read_byte(noACK); 
	lValue_Hum = (byte_1*256) + byte_2; //combines two bytes (8 bit) into a 16 bit (word) 
    
//		Humidity calculation 
    
	Rh_lin = (C1+(C2*lValue_Hum)+(C3*lValue_Hum*lValue_Hum)); 
	if((Rh_lin)>100) Rh_lin=100; //Ceiling for RH measurment 
	if((Rh_lin)<0.1) Rh_lin=0.1; //Floor for RH measurment 
    
    
//		Display to LCD 


	if (gcount>gintT){
		print_rhgraph(gX,(int)Value, Temp/20, (int)Rh_lin);						//  xvbg	(CACƃvbgdȂꍇ̏܂ށj


		if (gX<47){
			gX++;
		}
		else{
			gX = 0;
		}
		gcount = 0;
	}
	else{
			gcount++;
	}

	print_RH((int)(Rh_lin*10.0));

}
